//
//  RuleEditorTestAppDelegate.m
//  RuleEditorTest
//

#import "RuleEditorTestAppDelegate.h"
#import "Criterion.h"


@implementation RuleEditorTestAppDelegate

- (void)awakeFromNib
{
	criteria = [[NSMutableArray alloc] init];
	
	[criteria addObject:[Criterion criterionWithName:@"From" children:
						 [Criterion criterionWithName:@"Contains" children:[TextFieldCriterion criterion], nil],
						 [Criterion criterionWithName:@"Ends with" children:[TextFieldCriterion criterion], nil],
						 nil]];
	[criteria addObject:[Criterion criterionWithName:@"To" children:
						 [Criterion criterionWithName:@"Contains" children:[TextFieldCriterion criterion], nil],
						 [Criterion criterionWithName:@"Ends with" children:[TextFieldCriterion criterion], nil],
						 nil]];
	[criteria addObject:[SeparatorCriterion criterion]];	
	[criteria addObject:[Criterion criterionWithName:@"Message Type" children:
						 [Criterion criterionWithName:@"is" children:
						  [Criterion criterionWithName:@"Mail"],
						  [Criterion criterionWithName:@"Note"],
						  [Criterion criterionWithName:@"RSS"],
						  nil],
						 nil]];
	[criteria addObject:[SeparatorCriterion criterion]];	
	[criteria addObject:[Criterion criterionWithName:@"Message is Junk Mail"]];
	[criteria addObject:[SeparatorCriterion criterion]];	
	[criteria addObject:[Criterion criterionWithName:@"Account" children:
						 [Criterion criterionWithName:@"steve@apple.com"],
						 [Criterion criterionWithName:@"bill@microsoft.com"],
						 nil]];
}

- (NSInteger)ruleEditor:(NSRuleEditor *)editor numberOfChildrenForCriterion:(id)criterion withRowType:(NSRuleEditorRowType)rowType
{
	if (criterion == nil)
		return [criteria count];
	return [criterion numberOfChildren];
}

- (id)ruleEditor:(NSRuleEditor *)editor child:(NSInteger)index forCriterion:(id)criterion withRowType:(NSRuleEditorRowType)rowType
{
	if (criterion == nil)
		return [criteria objectAtIndex:index];
	return [criterion childAtIndex:index];
}

- (id)ruleEditor:(NSRuleEditor *)editor displayValueForCriterion:(id)criterion inRow:(NSInteger)row
{
	return [criterion displayValue];
}

@end
